/* fw_livevar.h

  Living variables

*/

#ifndef _FW_LIVEVAR_H
#define _FW_LIVEVAR_H

#include "../framework.h"
#include "../fwtools.h"



Element livevar_iota();
Element livevar_supremum(Element a, Element b);
Element livevar_bottom();
Element livevar_transfer(FlowNode g, Element a);
int livevar_eq(Element a, Element b);
void slivevar_deref(Element a);
Element slivevar_ref(Element a);
char *livevar_print(Element a);
int livevar_initfunc();
void livevar_finalizefunc();
FrameWork fw_livevar_createFrameWork(int direction);

#endif
