/* 
   guictrl.h
   Interface for communicating with the
   GUI


*/

#ifndef _GUICTRL_H 
#define _GUICTRL_H 

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "parsercontrol.h"
#include "parsetree.h"
#include "symboltable.h"
#include "flownode.h"
#include "frame_managing.h"





/*
  void newSource(char *filename)
  Tries to open and parse the file with the given filename,
  and builds the FlowGraph
*/
int newSource(char *filename);

/*
  void printAnalysisList()
  Prints the descriptions of the analysis list to stdout
*/
void printAnalysisList();


int guicontrol();


/* Output procedures for the graphical interface (dot-files) */

void outputFlowGraph(FlowGraph g, FrameWork fw);

void outputFlowGraph_simple(FlowGraph g);


#endif
