/* labellist.h

  28.04.2004

  Provides an ADT for storing
  the given label names

*/

#ifndef _LABEL_H

#define _LABEL_H

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

typedef struct LabelList_
{
  int id;
  char *name;
  struct LabelList_ *next;
}* LabelList;

/* LabelList createLabelList()
   Returns an empty LabelList
*/ 
LabelList createLabelList();

LabelList addLabel(LabelList l, int id, char *name);

int existsLabel(LabelList l, int id);

char *findLabelbyID(LabelList l, int id);

int findLabelbyName(LabelList l, char * s);


#endif
