/*****************************
  
  parsercontrol.h
  
  27.03.2004
  
  Provides an interface for
  the yacc parser and the 
  parsetree
*****************************/


#ifndef _parsercontrol_h 

#define _parsercontrol_h

#include <stdio.h>
#include <stdlib.h>
#include "symboltable.h"
#include "parsetree.h"

int parseFile(char *filename);

int evalBoolExpr(ParseTree tree, SymbolTable t);

int evalArithExpr(ParseTree tree, SymbolTable t);

void execute(ParseTree tree, SymbolTable t);

void inOrder(ParseTree tree);

void inOrderCommand(ParseTree tree);
#endif
