#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 3 "parser.y"
#include "parsetree.h"
#include "symboltable.h"
#include "parsercontrol.h"
#include <stdio.h>
#include "labellist.h"
#include "framework.h"
 ParseTree parsetree = NULL;
 extern char * yytext;
 int nrcommand = 0;
 extern SymbolTable vartable;
 extern int row;
 LabelList labellist = NULL;
 int parsing_ok = 1;
 extern char errtoken[128];
 extern int lexing_ok;
#line 33 "y.tab.c"
#define YYERRCODE 256
#define INTEGER 257
#define VARIABLE 258
#define TRUE 259
#define FALSE 260
#define IF 261
#define THEN 262
#define ELSE 263
#define FI 264
#define WHILE 265
#define DO 266
#define OD 267
#define SKIP 268
#define ASSIGN 269
#define ENDSTATEMENT 270
#define EQUAL 271
#define NOTEQUAL 272
#define SMALLEREQUAL 273
#define GREATEREQUAL 274
#define SMALLER 275
#define GREATER 276
#define NOT 277
#define AND 278
#define OR 279
#define SEMICOLON 280
#define LPAR 281
#define RPAR 282
#define NEG 283
#define PLUS 284
#define MINUS 285
#define MUL 286
#define DIV 287
#define MOD 288
#define POT 289
#define ERROR 290
#define SEQ 291
#define GET 292
#define PUT 293
#define LABEL 294
#define ADD 295
#define SUB 296
#define UMINUS 297
const short yylhs[] = {                                        -1,
    0,    0,    2,    2,    1,    1,    1,    1,    1,    3,
    4,    5,    6,   10,   10,    7,    7,    7,    7,    7,
    7,    7,    8,    8,    8,    8,    8,    8,    9,    9,
    9,    9,    9,    9,    9,    9,    9,    9,
};
const short yylen[] = {                                         2,
    3,    1,    2,    1,    1,    1,    1,    1,    1,    1,
    7,    5,    3,    4,    4,    1,    1,    1,    3,    3,
    2,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    2,    3,    1,    1,
};
const short yydefred[] = {                                      0,
    0,    0,    0,   10,    0,    0,    0,    0,    4,    0,
    5,    6,    7,    8,    9,    0,   37,   38,   16,   17,
    0,    0,    0,    0,   18,    0,    0,    0,    0,    3,
    0,    0,    0,   21,    0,    0,   35,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    1,    0,   22,   36,    0,
   19,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   34,    0,   14,   15,    0,   12,    0,
   11,
};
const short yydgoto[] = {                                       8,
    9,   10,   11,   12,   13,   14,   24,   25,   26,   15,
};
const short yysindex[] = {                                   -249,
 -263, -185, -185,    0, -273, -266, -235,    0,    0, -267,
    0,    0,    0,    0,    0, -254,    0,    0,    0,    0,
 -185, -185, -254, -160,    0, -115, -261, -234, -254,    0,
 -249, -254, -122,    0, -268, -134,    0, -249, -185, -185,
 -254, -254, -254, -254, -254, -254, -254, -254, -254, -254,
 -254, -254, -249, -257, -107,    0,  -99,    0,    0, -231,
    0, -244, -122, -122, -122, -122, -122, -122, -210, -210,
 -260, -260, -260,    0, -230,    0,    0, -249,    0, -218,
    0,
};
const short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  131,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  129,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -146, -226, -181, -175, -167, -157, -152,   82,  106,
    1,   28,   55,    0,    0,    0,    0,    0,    0,    0,
    0,
};
const short yygindex[] = {                                    -31,
   42,    0,    0,    0,    0,    0,   -1,    0,   19,    0,
};
#define YYTABLESIZE 409
const short yytable[] = {                                      56,
   31,   27,   17,   18,   53,   16,   60,   28,    1,   39,
   40,    2,   31,   58,   29,    3,   39,   40,    4,   34,
   35,   75,    1,   54,   76,    2,   32,   32,   52,    3,
   23,   78,    4,   39,   33,   23,   79,   61,   62,   23,
   36,   37,    5,    6,    7,   81,   80,   55,   30,    0,
   57,   23,   23,    0,   33,   23,    5,    6,    0,   63,
   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,
   74,   17,   18,   19,   20,   49,   50,   51,   52,    0,
   24,   29,    0,    0,   24,    0,   25,    0,    0,    0,
   25,   21,    0,    0,   27,   22,   24,   24,   27,   23,
   24,   38,   25,   25,   26,   30,   25,    0,   26,   28,
   27,   27,    0,   28,   27,   20,    0,   39,   40,   20,
   26,   26,    0,    0,   26,   28,   28,    0,   13,   28,
    2,    0,   20,    0,    0,   20,   41,   42,   43,   44,
   45,   46,    0,    0,    0,    0,    0,   59,    0,   47,
   48,   49,   50,   51,   52,   41,   42,   43,   44,   45,
   46,   47,   48,   49,   50,   51,   52,    0,   47,   48,
   49,   50,   51,   52,   77,    0,   47,   48,   49,   50,
   51,   52,   59,    0,   47,   48,   49,   50,   51,   52,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   31,   31,   31,    0,   31,   31,    0,    0,
    0,   31,   31,   31,   31,   31,   31,    0,   31,   31,
   31,    0,   31,    0,   31,   31,   31,   31,   31,   32,
   32,   32,    0,   32,   32,    0,    0,    0,   32,   32,
   32,   32,   32,   32,    0,   32,   32,   32,    0,   32,
    0,   32,   32,   32,   32,   32,   33,   33,   33,    0,
   33,   33,    0,    0,    0,   33,   33,   33,   33,   33,
   33,    0,   33,   33,   33,    0,   33,    0,   33,   33,
   33,   33,   33,   29,   29,   29,    0,   29,   29,    0,
    0,    0,   29,   29,   29,   29,   29,   29,    0,   29,
   29,   29,    0,   29,    0,   29,   29,   30,   30,   30,
    0,   30,   30,    0,    0,    0,   30,   30,   30,   30,
   30,   30,    0,   30,   30,   30,    0,   30,    0,   30,
   30,   13,   13,    2,    2,   13,    0,    2,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   13,
};
const short yycheck[] = {                                      31,
    0,    3,  257,  258,  266,  269,   38,  281,  258,  278,
  279,  261,  280,  282,  281,  265,  278,  279,  268,   21,
   22,   53,  258,  258,  282,  261,  281,    0,  289,  265,
  285,  263,  268,  278,   16,  262,  267,   39,   40,  266,
   22,   23,  292,  293,  294,  264,   78,   29,    7,   -1,
   32,  278,  279,   -1,    0,  282,  292,  293,   -1,   41,
   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
   52,  257,  258,  259,  260,  286,  287,  288,  289,   -1,
  262,    0,   -1,   -1,  266,   -1,  262,   -1,   -1,   -1,
  266,  277,   -1,   -1,  262,  281,  278,  279,  266,  285,
  282,  262,  278,  279,  262,    0,  282,   -1,  266,  262,
  278,  279,   -1,  266,  282,  262,   -1,  278,  279,  266,
  278,  279,   -1,   -1,  282,  278,  279,   -1,    0,  282,
    0,   -1,  279,   -1,   -1,  282,  271,  272,  273,  274,
  275,  276,   -1,   -1,   -1,   -1,   -1,  282,   -1,  284,
  285,  286,  287,  288,  289,  271,  272,  273,  274,  275,
  276,  284,  285,  286,  287,  288,  289,   -1,  284,  285,
  286,  287,  288,  289,  282,   -1,  284,  285,  286,  287,
  288,  289,  282,   -1,  284,  285,  286,  287,  288,  289,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  262,  263,  264,   -1,  266,  267,   -1,   -1,
   -1,  271,  272,  273,  274,  275,  276,   -1,  278,  279,
  280,   -1,  282,   -1,  284,  285,  286,  287,  288,  262,
  263,  264,   -1,  266,  267,   -1,   -1,   -1,  271,  272,
  273,  274,  275,  276,   -1,  278,  279,  280,   -1,  282,
   -1,  284,  285,  286,  287,  288,  262,  263,  264,   -1,
  266,  267,   -1,   -1,   -1,  271,  272,  273,  274,  275,
  276,   -1,  278,  279,  280,   -1,  282,   -1,  284,  285,
  286,  287,  288,  262,  263,  264,   -1,  266,  267,   -1,
   -1,   -1,  271,  272,  273,  274,  275,  276,   -1,  278,
  279,  280,   -1,  282,   -1,  284,  285,  262,  263,  264,
   -1,  266,  267,   -1,   -1,   -1,  271,  272,  273,  274,
  275,  276,   -1,  278,  279,  280,   -1,  282,   -1,  284,
  285,  263,  264,  263,  264,  267,   -1,  267,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
};
#define YYFINAL 8
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 297
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"INTEGER","VARIABLE","TRUE",
"FALSE","IF","THEN","ELSE","FI","WHILE","DO","OD","SKIP","ASSIGN",
"ENDSTATEMENT","EQUAL","NOTEQUAL","SMALLEREQUAL","GREATEREQUAL","SMALLER",
"GREATER","NOT","AND","OR","SEMICOLON","LPAR","RPAR","NEG","PLUS","MINUS","MUL",
"DIV","MOD","POT","ERROR","SEQ","GET","PUT","LABEL","ADD","SUB","UMINUS",
};
const char * const yyrule[] = {
"$accept : PROG",
"PROG : STATEMENT SEMICOLON PROG",
"PROG : STATEMENT",
"STATEMENT : LABEL SIMPLESTATEMENT",
"STATEMENT : SIMPLESTATEMENT",
"SIMPLESTATEMENT : SKIPSTATEMENT",
"SIMPLESTATEMENT : IFSTATEMENT",
"SIMPLESTATEMENT : WHILESTATEMENT",
"SIMPLESTATEMENT : ASSIGNSTATEMENT",
"SIMPLESTATEMENT : IOSTATEMENT",
"SKIPSTATEMENT : SKIP",
"IFSTATEMENT : IF BOOLEXPR THEN PROG ELSE PROG FI",
"WHILESTATEMENT : WHILE BOOLEXPR DO PROG OD",
"ASSIGNSTATEMENT : VARIABLE ASSIGN ARITHEXPR",
"IOSTATEMENT : GET LPAR VARIABLE RPAR",
"IOSTATEMENT : PUT LPAR ARITHEXPR RPAR",
"BOOLEXPR : TRUE",
"BOOLEXPR : FALSE",
"BOOLEXPR : RELEXPR",
"BOOLEXPR : BOOLEXPR AND BOOLEXPR",
"BOOLEXPR : BOOLEXPR OR BOOLEXPR",
"BOOLEXPR : NOT BOOLEXPR",
"BOOLEXPR : LPAR BOOLEXPR RPAR",
"RELEXPR : ARITHEXPR EQUAL ARITHEXPR",
"RELEXPR : ARITHEXPR NOTEQUAL ARITHEXPR",
"RELEXPR : ARITHEXPR SMALLEREQUAL ARITHEXPR",
"RELEXPR : ARITHEXPR SMALLER ARITHEXPR",
"RELEXPR : ARITHEXPR GREATEREQUAL ARITHEXPR",
"RELEXPR : ARITHEXPR GREATER ARITHEXPR",
"ARITHEXPR : ARITHEXPR PLUS ARITHEXPR",
"ARITHEXPR : ARITHEXPR MINUS ARITHEXPR",
"ARITHEXPR : ARITHEXPR MUL ARITHEXPR",
"ARITHEXPR : ARITHEXPR DIV ARITHEXPR",
"ARITHEXPR : ARITHEXPR MOD ARITHEXPR",
"ARITHEXPR : ARITHEXPR POT ARITHEXPR",
"ARITHEXPR : MINUS ARITHEXPR",
"ARITHEXPR : LPAR ARITHEXPR RPAR",
"ARITHEXPR : INTEGER",
"ARITHEXPR : VARIABLE",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 213 "parser.y"




int yyerror(char *s)
{
    if (lexing_ok)
    {
	/*printf("ERROR\n (Zeile %d): %s (Token <%s>) \n", row, s, yytext);*/
	strcpy(errtoken, yytext);
	
    }
    
    parsing_ok = 0;
}

int yywrap()
{
	return 1;	
}
#line 323 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 49 "parser.y"
{
    if (yyvsp[0].tree->type == SEQ)
    {
	yyval.tree = yyvsp[0].tree;
	addSubTree(yyval.tree, yyvsp[-2].tree, FIRST); 
	parsetree = yyval.tree;
     }
     else
     {
	yyval.tree = createParseTree(SEQ);
	addSubTree(yyval.tree, yyvsp[-2].tree, FIRST);
	addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	parsetree = yyval.tree;
     }
    
    }
break;
case 2:
#line 65 "parser.y"
{yyval.tree = yyvsp[0].tree; parsetree = yyvsp[0].tree; }
break;
case 3:
#line 68 "parser.y"
{nrcommand++; yyval.tree = yyvsp[0].tree; yyval.tree->label = nrcommand; labellist = addLabel(labellist, nrcommand, yyvsp[-1].label);}
break;
case 4:
#line 69 "parser.y"
{nrcommand++; yyval.tree = yyvsp[0].tree; yyval.tree->label = nrcommand;}
break;
case 5:
#line 73 "parser.y"
{yyval.tree = yyvsp[0].tree;}
break;
case 6:
#line 74 "parser.y"
{yyval.tree = yyvsp[0].tree;}
break;
case 7:
#line 75 "parser.y"
{yyval.tree = yyvsp[0].tree;}
break;
case 8:
#line 76 "parser.y"
{yyval.tree = yyvsp[0].tree;}
break;
case 9:
#line 77 "parser.y"
{yyval.tree = yyvsp[0].tree;}
break;
case 10:
#line 81 "parser.y"
{yyval.tree = createParseTree(SKIP);}
break;
case 11:
#line 85 "parser.y"
{yyval.tree = createParseTree(IF);
	      addSubTree(yyval.tree, yyvsp[-5].tree, LAST);
	      addSubTree(yyval.tree, yyvsp[-3].tree, LAST);
	      addSubTree(yyval.tree, yyvsp[-1].tree, LAST);
             }
break;
case 12:
#line 93 "parser.y"
{yyval.tree = createParseTree(WHILE);
		 addSubTree(yyval.tree, yyvsp[-3].tree, LAST);
		 addSubTree(yyval.tree, yyvsp[-1].tree, LAST);     
		}
break;
case 13:
#line 100 "parser.y"
{yyval.tree = createParseTree(ASSIGN);
		  addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
		  addSubTree(yyval.tree, yyvsp[0].tree, LAST);
		 }
break;
case 14:
#line 108 "parser.y"
{yyval.tree = createParseTree(GET);
		 addSubTree(yyval.tree, yyvsp[-1].tree, LAST);
		}
break;
case 15:
#line 112 "parser.y"
{yyval.tree = createParseTree(PUT);
		 addSubTree(yyval.tree, yyvsp[-1].tree, LAST);
		}
break;
case 16:
#line 117 "parser.y"
{yyval.tree = yyvsp[0].tree;}
break;
case 17:
#line 118 "parser.y"
{yyval.tree = yyvsp[0].tree;}
break;
case 18:
#line 119 "parser.y"
{yyval.tree = yyvsp[0].tree;}
break;
case 19:
#line 121 "parser.y"
{yyval.tree = createParseTree(AND);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 20:
#line 126 "parser.y"
{yyval.tree = createParseTree(OR);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 21:
#line 131 "parser.y"
{ yyval.tree = createParseTree(NOT);
	      addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 22:
#line 134 "parser.y"
{yyval.tree = yyvsp[-1].tree;}
break;
case 23:
#line 138 "parser.y"
{yyval.tree = createParseTree(EQUAL);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 24:
#line 143 "parser.y"
{yyval.tree = createParseTree(NOTEQUAL);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 25:
#line 148 "parser.y"
{yyval.tree = createParseTree(SMALLEREQUAL);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 26:
#line 153 "parser.y"
{yyval.tree = createParseTree(SMALLER);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 27:
#line 158 "parser.y"
{yyval.tree = createParseTree(GREATEREQUAL);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 28:
#line 163 "parser.y"
{yyval.tree = createParseTree(GREATER);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 29:
#line 170 "parser.y"
{yyval.tree = createParseTree(ADD);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 30:
#line 175 "parser.y"
{yyval.tree = createParseTree(SUB);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 31:
#line 180 "parser.y"
{yyval.tree = createParseTree(MUL);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 32:
#line 185 "parser.y"
{yyval.tree = createParseTree(DIV);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 33:
#line 190 "parser.y"
{yyval.tree = createParseTree(MOD);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 34:
#line 195 "parser.y"
{yyval.tree = createParseTree(POT);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 35:
#line 200 "parser.y"
{yyval.tree = createParseTree(NEG);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
break;
case 36:
#line 204 "parser.y"
{yyval.tree = yyvsp[-1].tree;}
break;
case 37:
#line 206 "parser.y"
{yyval.tree = yyvsp[0].tree;}
break;
case 38:
#line 208 "parser.y"
{yyval.tree = yyvsp[0].tree;}
break;
#line 745 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
