/* fw_init.h

Initialized Variables
*/

#ifndef _FW_INIT_H
#define _FW_INIT_H

#include <stdlib.h>
#include "../symboltable.h"
#include "../parsercontrol.h"
#include "../varset.h"
#include "../framework.h"

#include "../fwtools.h"



/* iota Element  */
Element init_iota();
Element init_supremum(Element a, Element b);
Element init_bottom();
Element init_transfer(FlowNode g, Element a);
int init_eq(Element a, Element b);
void init_deref(Element a);
Element init_ref(Element a);

char *init_print(Element a);
int init_initfunc();
void init_finalizefunc();

FrameWork fw_init_createFrameWork(int direction);

#endif
