/* fw_simple.h

  Simple Framework testing the abilities of framework.h
  
  Set: N| with inf (inf = -1)
  transfer-function: INC
  bottom = inf (= -1)

*/

#ifndef _FW_SIMPLE_H
#define _FW_SIMPLE_H

#include "../framework.h"
#include "../generic_list.h"

#define MAX_DIGITS_INT 20

/* iota Element  */
Element simple_iota();
Element simple_supremum(Element a, Element b);
Element simple_bottom();
Element simple_transfer(FlowNode g, Element a);
int simple_eq(Element a, Element b);
void simple_deref(Element a);
Element simple_ref(Element a);
char *simple_print(Element a);
FrameWork fw_simple_createFrameWork(int direction);
int simple_initfunc();
void simple_finalizefunc();

#endif
