/* fw_slivevar.h

  Strong / weak living variables

*/

#ifndef _FW_SLIVEVAR_H
#define _FW_SLIVEVAR_H

#include "../framework.h"
#include "../fwtools.h"



/* iota Element  */
Element slivevar_iota();
Element slivevar_supremum(Element a, Element b);
Element slivevar_bottom();
Element slivevar_transfer(FlowNode g, Element a);
int slivevar_eq(Element a, Element b);
void slivevar_derefe(Element a);
Element slivevar_ref(Element a);
char *slivevar_print(Element a);
int slivevar_initfunc();
void slivevar_finalizefunc();

FrameWork fw_slivevar_createFrameWork(int direction);

#endif
