/* A Bison parser, made from parser.y, by GNU bison 1.75.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON	1

/* Pure parsers.  */
#define YYPURE	0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     INTEGER = 258,
     VARIABLE = 259,
     TRUE = 260,
     FALSE = 261,
     IF = 262,
     THEN = 263,
     ELSE = 264,
     FI = 265,
     WHILE = 266,
     DO = 267,
     OD = 268,
     SKIP = 269,
     ASSIGN = 270,
     ENDSTATEMENT = 271,
     EQUAL = 272,
     NOTEQUAL = 273,
     SMALLEREQUAL = 274,
     GREATEREQUAL = 275,
     SMALLER = 276,
     GREATER = 277,
     NOT = 278,
     AND = 279,
     OR = 280,
     SEMICOLON = 281,
     LPAR = 282,
     RPAR = 283,
     NEG = 284,
     PLUS = 285,
     MINUS = 286,
     MUL = 287,
     DIV = 288,
     MOD = 289,
     POT = 290,
     ERROR = 291,
     SEQ = 292,
     GET = 293,
     PUT = 294,
     LABEL = 295,
     ADD = 296,
     SUB = 297,
     UMINUS = 298
   };
#endif
#define INTEGER 258
#define VARIABLE 259
#define TRUE 260
#define FALSE 261
#define IF 262
#define THEN 263
#define ELSE 264
#define FI 265
#define WHILE 266
#define DO 267
#define OD 268
#define SKIP 269
#define ASSIGN 270
#define ENDSTATEMENT 271
#define EQUAL 272
#define NOTEQUAL 273
#define SMALLEREQUAL 274
#define GREATEREQUAL 275
#define SMALLER 276
#define GREATER 277
#define NOT 278
#define AND 279
#define OR 280
#define SEMICOLON 281
#define LPAR 282
#define RPAR 283
#define NEG 284
#define PLUS 285
#define MINUS 286
#define MUL 287
#define DIV 288
#define MOD 289
#define POT 290
#define ERROR 291
#define SEQ 292
#define GET 293
#define PUT 294
#define LABEL 295
#define ADD 296
#define SUB 297
#define UMINUS 298




/* Copy the first part of user declarations.  */
#line 2 "parser.y"

#include "parsetree.h"
#include "symboltable.h"
#include "parsercontrol.h"
#include <stdio.h>
#include "labellist.h"
#include "framework.h"
  ParseTree result;
 extern char * yytext;
 int nrcommand = 0;
 extern SymbolTable vartable;
 extern int row;
 LabelList labellist = NULL;
 int parsing_ok = 1;


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#ifndef YYSTYPE
typedef int yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif

#ifndef YYLTYPE
typedef struct yyltype
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} yyltype;
# define YYLTYPE yyltype
# define YYLTYPE_IS_TRIVIAL 1
#endif

/* Copy the second part of user declarations.  */


/* Line 213 of /usr/share/bison/yacc.c.  */
#line 195 "parser.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];	\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  31
#define YYLAST   147

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  44
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  12
/* YYNRULES -- Number of rules. */
#define YYNRULES  39
/* YYNRULES -- Number of states. */
#define YYNSTATES  83

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   298

#define YYTRANSLATE(X) \
  ((unsigned)(X) <= YYMAXUTOK ? yytranslate[X] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     7,     9,    12,    14,    16,    18,    20,
      22,    24,    26,    34,    40,    44,    49,    54,    56,    58,
      60,    64,    68,    71,    75,    79,    83,    87,    91,    95,
      99,   103,   107,   111,   115,   119,   123,   126,   130,   132
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      45,     0,    -1,    46,    26,    45,    -1,    46,    -1,    40,
      47,    -1,    47,    -1,    48,    -1,    49,    -1,    50,    -1,
      51,    -1,    52,    -1,    14,    -1,     7,    53,     8,    45,
       9,    45,    10,    -1,    11,    53,    12,    45,    13,    -1,
       4,    15,    55,    -1,    38,    27,     4,    28,    -1,    39,
      27,    55,    28,    -1,     5,    -1,     6,    -1,    54,    -1,
      53,    24,    53,    -1,    53,    25,    53,    -1,    23,    53,
      -1,    27,    53,    28,    -1,    55,    17,    55,    -1,    55,
      18,    55,    -1,    55,    19,    55,    -1,    55,    21,    55,
      -1,    55,    20,    55,    -1,    55,    22,    55,    -1,    55,
      30,    55,    -1,    55,    31,    55,    -1,    55,    32,    55,
      -1,    55,    33,    55,    -1,    55,    34,    55,    -1,    55,
      35,    55,    -1,    31,    55,    -1,    27,    55,    28,    -1,
       3,    -1,     4,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned char yyrline[] =
{
       0,    46,    46,    62,    65,    66,    69,    71,    72,    73,
      74,    78,    81,    89,    96,   104,   108,   114,   115,   116,
     117,   122,   127,   131,   134,   139,   144,   149,   154,   159,
     166,   171,   176,   181,   186,   191,   196,   200,   202,   204
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "INTEGER", "VARIABLE", "TRUE", "FALSE", 
  "IF", "THEN", "ELSE", "FI", "WHILE", "DO", "OD", "SKIP", "ASSIGN", 
  "ENDSTATEMENT", "EQUAL", "NOTEQUAL", "SMALLEREQUAL", "GREATEREQUAL", 
  "SMALLER", "GREATER", "NOT", "AND", "OR", "SEMICOLON", "LPAR", "RPAR", 
  "NEG", "PLUS", "MINUS", "MUL", "DIV", "MOD", "POT", "ERROR", "SEQ", 
  "GET", "PUT", "LABEL", "ADD", "SUB", "UMINUS", "$accept", "PROG", 
  "STATEMENT", "SIMPLESTATEMENT", "SKIPSTATEMENT", "IFSTATEMENT", 
  "WHILESTATEMENT", "ASSIGNSTATEMENT", "IOSTATEMENT", "BOOLEXPR", 
  "RELEXPR", "ARITHEXPR", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    44,    45,    45,    46,    46,    47,    47,    47,    47,
      47,    48,    49,    50,    51,    52,    52,    53,    53,    53,
      53,    53,    53,    53,    54,    54,    54,    54,    54,    54,
      55,    55,    55,    55,    55,    55,    55,    55,    55,    55
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     3,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     7,     5,     3,     4,     4,     1,     1,     1,
       3,     3,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     0,    11,     0,     0,     0,     0,     3,
       5,     6,     7,     8,     9,    10,     0,    38,    39,    17,
      18,     0,     0,     0,     0,    19,     0,     0,     0,     0,
       4,     1,     0,     0,    14,    22,     0,     0,    36,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     2,     0,    23,
      37,     0,    20,    21,    24,    25,    26,    28,    27,    29,
      30,    31,    32,    33,    34,    35,     0,    15,    16,     0,
      13,     0,    12
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     8,     9,    10,    11,    12,    13,    14,    15,    24,
      25,    26
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -33
static const yysigned_char yypact[] =
{
       4,   -13,    70,    70,   -33,   -22,   -21,    57,    10,    -9,
     -33,   -33,   -33,   -33,   -33,   -33,     0,   -33,   -33,   -33,
     -33,    70,    70,     0,     1,   -33,   104,     9,    20,     0,
     -33,   -33,     4,     0,    55,   -33,   -12,    85,   -33,     4,
      70,    70,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     4,   -14,    49,   -33,   112,   -33,
     -33,    19,   -33,     8,    55,    55,    55,    55,    55,    55,
      76,    76,     2,     2,     2,   -33,    22,   -33,   -33,     4,
     -33,    31,   -33
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -33,   -32,   -33,    38,   -33,   -33,   -33,   -33,   -33,    -2,
     -33,     7
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, parse error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      57,    27,    16,    17,    18,    28,    29,    61,     1,    39,
      31,     2,    40,    41,    77,     3,    59,    32,     4,    35,
      36,    54,    76,    34,    55,    40,    41,    33,    79,    37,
      38,    23,    40,    40,    41,    80,    56,    53,    62,    63,
      58,    82,     5,     6,     7,    30,     0,    81,     0,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,     1,     0,     0,     2,     0,     0,     0,     3,     0,
       0,     4,     0,    17,    18,    19,    20,    78,     0,    48,
      49,    50,    51,    52,    53,    48,    49,    50,    51,    52,
      53,     0,     0,    21,     0,     5,     6,    22,     0,     0,
       0,    23,    42,    43,    44,    45,    46,    47,    50,    51,
      52,    53,     0,    60,     0,    48,    49,    50,    51,    52,
      53,    42,    43,    44,    45,    46,    47,     0,     0,     0,
       0,     0,     0,     0,    48,    49,    50,    51,    52,    53,
      60,     0,    48,    49,    50,    51,    52,    53
};

static const yysigned_char yycheck[] =
{
      32,     3,    15,     3,     4,    27,    27,    39,     4,     8,
       0,     7,    24,    25,    28,    11,    28,    26,    14,    21,
      22,    12,    54,    16,     4,    24,    25,    27,     9,    22,
      23,    31,    24,    24,    25,    13,    29,    35,    40,    41,
      33,    10,    38,    39,    40,     7,    -1,    79,    -1,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,     4,    -1,    -1,     7,    -1,    -1,    -1,    11,    -1,
      -1,    14,    -1,     3,     4,     5,     6,    28,    -1,    30,
      31,    32,    33,    34,    35,    30,    31,    32,    33,    34,
      35,    -1,    -1,    23,    -1,    38,    39,    27,    -1,    -1,
      -1,    31,    17,    18,    19,    20,    21,    22,    32,    33,
      34,    35,    -1,    28,    -1,    30,    31,    32,    33,    34,
      35,    17,    18,    19,    20,    21,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      28,    -1,    30,    31,    32,    33,    34,    35
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     4,     7,    11,    14,    38,    39,    40,    45,    46,
      47,    48,    49,    50,    51,    52,    15,     3,     4,     5,
       6,    23,    27,    31,    53,    54,    55,    53,    27,    27,
      47,     0,    26,    27,    55,    53,    53,    55,    55,     8,
      24,    25,    17,    18,    19,    20,    21,    22,    30,    31,
      32,    33,    34,    35,    12,     4,    55,    45,    55,    28,
      28,    45,    53,    53,    55,    55,    55,    55,    55,    55,
      55,    55,    55,    55,    55,    55,    45,    28,    28,     9,
      13,    45,    10
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)           \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#define YYLEX	yylex ()

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*-----------------------------.
| Print this symbol on YYOUT.  |
`-----------------------------*/

static void
#if defined (__STDC__) || defined (__cplusplus)
yysymprint (FILE* yyout, int yytype, YYSTYPE yyvalue)
#else
yysymprint (yyout, yytype, yyvalue)
    FILE* yyout;
    int yytype;
    YYSTYPE yyvalue;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvalue;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyout, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyout, yytoknum[yytype], yyvalue);
# endif
    }
  else
    YYFPRINTF (yyout, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyout, ")");
}
#endif /* YYDEBUG. */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
#if defined (__STDC__) || defined (__cplusplus)
yydestruct (int yytype, YYSTYPE yyvalue)
#else
yydestruct (yytype, yyvalue)
    int yytype;
    YYSTYPE yyvalue;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvalue;

  switch (yytype)
    {
      default:
        break;
    }
}



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of parse errors so far.  */
int yynerrs;


int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with.  */

  if (yychar <= 0)		/* This means end of input.  */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more.  */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

      /* We have to keep this `#if YYDEBUG', since we use variables
	 which are defined only if `YYDEBUG' is set.  */
      YYDPRINTF ((stderr, "Next token is "));
      YYDSYMPRINT ((stderr, yychar1, yylval));
      YYDPRINTF ((stderr, "\n"));
    }

  /* If the proper action on seeing token YYCHAR1 is to reduce or to
     detect an error, take that action.  */
  yyn += yychar1;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yychar1)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];



#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn - 1, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] >= 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif
  switch (yyn)
    {
        case 2:
#line 47 "parser.y"
    {
    if (yyvsp[0].tree->type == SEQ)
    {
	yyval.tree = yyvsp[0].tree;
	addSubTree(yyval.tree, yyvsp[-2].tree, FIRST); 
	result = yyval.tree;
     }
     else
     {
	yyval.tree = createParseTree(SEQ);
	addSubTree(yyval.tree, yyvsp[-2].tree, FIRST);
	addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	result = yyval.tree;
     }
    }
    break;

  case 3:
#line 62 "parser.y"
    {yyval.tree = yyvsp[0].tree; result = yyvsp[0].tree;}
    break;

  case 4:
#line 65 "parser.y"
    {printf("NEUER BEFEHL: %d", nrcommand+1); nrcommand++; yyval.tree = yyvsp[0].tree; yyval.tree->label = nrcommand; labellist = addLabel(labellist, nrcommand, yyvsp[-1].label);}
    break;

  case 5:
#line 66 "parser.y"
    {nrcommand++; yyval.tree = yyvsp[0].tree; yyval.tree->label = nrcommand;}
    break;

  case 6:
#line 70 "parser.y"
    {yyval.tree = yyvsp[0].tree;}
    break;

  case 7:
#line 71 "parser.y"
    {yyval.tree = yyvsp[0].tree;}
    break;

  case 8:
#line 72 "parser.y"
    {yyval.tree = yyvsp[0].tree;}
    break;

  case 9:
#line 73 "parser.y"
    {yyval.tree = yyvsp[0].tree;}
    break;

  case 10:
#line 74 "parser.y"
    {yyval.tree = yyvsp[0].tree;}
    break;

  case 11:
#line 78 "parser.y"
    {yyval.tree = createParseTree(SKIP);}
    break;

  case 12:
#line 82 "parser.y"
    {yyval.tree = createParseTree(IF);
	      addSubTree(yyval.tree, yyvsp[-5].tree, LAST);
	      addSubTree(yyval.tree, yyvsp[-3].tree, LAST);
	      addSubTree(yyval.tree, yyvsp[-1].tree, LAST);
             }
    break;

  case 13:
#line 90 "parser.y"
    {yyval.tree = createParseTree(WHILE);
		 addSubTree(yyval.tree, yyvsp[-3].tree, LAST);
		 addSubTree(yyval.tree, yyvsp[-1].tree, LAST);     
		}
    break;

  case 14:
#line 97 "parser.y"
    {yyval.tree = createParseTree(ASSIGN);
		  addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
		  addSubTree(yyval.tree, yyvsp[0].tree, LAST);
		 }
    break;

  case 15:
#line 105 "parser.y"
    {yyval.tree = createParseTree(GET);
		 addSubTree(yyval.tree, yyvsp[-1].tree, LAST);
		}
    break;

  case 16:
#line 109 "parser.y"
    {yyval.tree = createParseTree(PUT);
		 addSubTree(yyval.tree, yyvsp[-1].tree, LAST);
		}
    break;

  case 17:
#line 114 "parser.y"
    {yyval.tree = yyvsp[0].tree;}
    break;

  case 18:
#line 115 "parser.y"
    {yyval.tree = yyvsp[0].tree;}
    break;

  case 19:
#line 116 "parser.y"
    {yyval.tree = yyvsp[0].tree;}
    break;

  case 20:
#line 118 "parser.y"
    {yyval.tree = createParseTree(AND);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 21:
#line 123 "parser.y"
    {yyval.tree = createParseTree(OR);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 22:
#line 128 "parser.y"
    { yyval.tree = createParseTree(NOT);
	      addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 23:
#line 131 "parser.y"
    {yyval.tree = yyvsp[-1].tree;}
    break;

  case 24:
#line 135 "parser.y"
    {yyval.tree = createParseTree(EQUAL);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 25:
#line 140 "parser.y"
    {yyval.tree = createParseTree(NOTEQUAL);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 26:
#line 145 "parser.y"
    {yyval.tree = createParseTree(SMALLEREQUAL);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 27:
#line 150 "parser.y"
    {yyval.tree = createParseTree(SMALLER);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 28:
#line 155 "parser.y"
    {yyval.tree = createParseTree(GREATEREQUAL);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 29:
#line 160 "parser.y"
    {yyval.tree = createParseTree(GREATER);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 30:
#line 167 "parser.y"
    {yyval.tree = createParseTree(ADD);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 31:
#line 172 "parser.y"
    {yyval.tree = createParseTree(SUB);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 32:
#line 177 "parser.y"
    {yyval.tree = createParseTree(MUL);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 33:
#line 182 "parser.y"
    {yyval.tree = createParseTree(DIV);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 34:
#line 187 "parser.y"
    {yyval.tree = createParseTree(MOD);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 35:
#line 192 "parser.y"
    {yyval.tree = createParseTree(POT);
	     addSubTree(yyval.tree, yyvsp[-2].tree, LAST);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 36:
#line 197 "parser.y"
    {yyval.tree = createParseTree(NEG);
	     addSubTree(yyval.tree, yyvsp[0].tree, LAST);
	    }
    break;

  case 37:
#line 201 "parser.y"
    {yyval.tree = yyvsp[-1].tree;}
    break;

  case 38:
#line 203 "parser.y"
    {yyval.tree = yyvsp[0].tree;}
    break;

  case 39:
#line 205 "parser.y"
    {yyval.tree = yyvsp[0].tree;}
    break;


    }

/* Line 1016 of /usr/share/bison/yacc.c.  */
#line 1353 "parser.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyssp > yyss)
	    {
	      YYDPRINTF ((stderr, "Error: popping "));
	      YYDSYMPRINT ((stderr,
			    yystos[*yyssp],
			    *yyvsp));
	      YYDPRINTF ((stderr, "\n"));
	      yydestruct (yystos[*yyssp], *yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yydestruct (yychar1, yylval);
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDPRINTF ((stderr, "Error: popping "));
      YYDSYMPRINT ((stderr,
		    yystos[*yyssp], *yyvsp));
      YYDPRINTF ((stderr, "\n"));

      yydestruct (yystos[yystate], *yyvsp);
      yyvsp--;
      yystate = *--yyssp;


#if YYDEBUG
      if (yydebug)
	{
	  short *yyssp1 = yyss - 1;
	  YYFPRINTF (stderr, "Error: state stack now");
	  while (yyssp1 != yyssp)
	    YYFPRINTF (stderr, " %d", *++yyssp1);
	  YYFPRINTF (stderr, "\n");
	}
#endif
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 209 "parser.y"





int yyerror(char *s)
{
  printf("\n>>> error (line %d): %s (token \"%s\") \n", row, s, yytext);
  parsing_ok = 0;
}

int yywrap()
{
	return 1;	
}


