/* whrun.c

  Includes the main procedure
  for the WHILE interpreter

  1.10.2004


*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "parsercontrol.h"

extern ParseTree parsetree;
extern SymbolTable vartable;



int main(int argc, char** argv)
{

  if (argc != 2)
    {
      printf("Gebrauch: whrun <FILENAME>");
      return;
    }
  else
    {
      printf("Datei %s wird geoeffnet\n", argv[1]);
      parseFile(argv[1]);
      inOrder(parsetree);
      printf("\n\n");
      execute(parsetree, vartable);
    }

}
